#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>
#include <bios.h>
#include <PROCESS.H>

#define FALSE	0
#define TRUE	-1
#define false	0
#define true	-1

// Funktionsprototypen
void 	handle_errors	(unsigned int err, int status);
void	trans_test 		(void);
void 	erase_chip		(void);
void 	lock_chip		(void);
void 	write_chip		(char* file);
void 	verify_chip		(char* file);
void	allocate		(void);
void	read_file		(char* file);

// Variablen
int 	COM;			// # der Schnittstelle
int 	a;			// allgemeiner Schleifenzhler
int 	l;			// lnge der eingelesenen datei
int 	msg;			// statusmeldungen?

char	s;			// Zwischenpuffer fr einzelnes Zeichen
char 	*buffer; 		// filebuffer

FILE	*in;			// filehandle

/****************************************************************************/

void 	main(int argc, char *argv[])
{
char *pch, fname[20];
int pdata;

//Bildschirm lschen
	clrscr();
//variablen initialisieren
	in=NULL;
	buffer=NULL;

	puts("Programming utility for use with AT89C2051 and serial programmer");
	puts("written by Erik Buchmann, version 26.9.98\n");

//Auswertung der Kommandozeilenparameter
// COM-Schnittstelle erfragen
	if ((argc > 1) && ((pch=strpbrk(argv[1],"1234"))!=NULL))
		{
		switch (*pch)
			{
			case '1': COM=0; break;
			case '2': COM=1; break;
			case '3': COM=2; break;
			case '4': COM=3; break;
			}
		puts ("trying to initialize port");
		handle_errors(_bios_serialcom(_COM_INIT,COM,_COM_CHR8 | _COM_STOP1 | _COM_NOPARITY | _COM_1200 ),TRUE);
		}
	else
		{
		puts( "Usage: PROGI /COMn [/ERASE] [/WRITE] [/VERIFY] [/LOCK] [/TEST] [/MSG] <file>" );
		exit( 255 );
		}

// statusmeldungen?
	msg=false;
	for (a=2;a<=argc;a++)
		{
		if (strcmpi(argv[a],"/MSG")==0)
			{
			a=10000;
			msg=true;
			}
		}

// test?
	for (a=2;a<=argc;a++)
		{
		if (strcmpi(argv[a],"/TEST")==0)
			{
			a=10000;
			trans_test();
			exit(0);
			}
		}

// erase?
	for (a=2;a<=argc;a++)
		{
		if (strcmpi(argv[a],"/ERASE")==0)
			{
			a=10000;
			erase_chip();
			}
		}
// write?
	for (a=2;a<=argc;a++)
		{
		if (strcmpi(argv[a],"/WRITE")==0)
			{
			a=10000;
			write_chip(argv[argc-1]);
			}
		}

// verify?
	for (a=2;a<=argc;a++)
		{
		if (strcmpi(argv[a],"/VERIFY")==0)
			{
			a=10000;
			verify_chip(argv[argc-1]);
			}
		}

// lock?
	for (a=2;a<=argc;a++)
		{
		if (strcmpi(argv[a],"/LOCK")==0)
			{
			a=10000;
			lock_chip();
			}
		}

puts("\nall actions are done.");
}

/****************************************************************************/
void handle_errors(unsigned int err, int status)
{
// err		Rckgabe von _bios_serialcom
// status   zeigt an, da eine Statusabfrage vorgenommen wird,
//			einige Fehler werden dann ignoriert
//			andere nur dann ausgegeben

if (err & (32768)){ puts(" -Time out"); }
if (err & (16384) && status ){ puts(" -Serial register for transmission is empty"); }
if (err & (8192)  && status ){ puts(" -Transmisstion buffer is empty"); }
if (err & (4096)) { puts(" -Break-Signal received"); }
if (err & (2048)) { puts(" -Framing-Error"); }
if (err & (1024)) { puts(" -Parity error"); }
if (err & ( 512)) { puts(" -Overflow"); }
if (err & ( 256)  && status ){ puts(" -Data ready"); }

if (status)
	{
	if (err & ( 128)) { puts(" -Received line signal detect"); }
	if (err & (  64)) { puts(" -Ring indicator"); }
	if (err & (  32)) { puts(" -Data set ready"); }
	if (err & (  16)) { puts(" -Clear to send"); }
	if (err & (   8)) { puts(" -Change in receive line signal detector"); }
	if (err & (   4)) { puts(" -Trailing edge ring detector"); }
	if (err & (   2)) { puts(" -Change in data set ready"); }
	if (err & (   1)) { puts(" -Change in clear to send"); }
	}
}


/****************************************************************************/
void	trans_test ()
{
puts ("\nperforming transmission test");
puts (" sending:   EBh 98h 80h");
handle_errors(_bios_serialcom(_COM_SEND,COM,0xEB ),FALSE);
handle_errors(_bios_serialcom(_COM_SEND,COM,0x98 ),FALSE);
handle_errors(_bios_serialcom(_COM_SEND,COM,128 ),FALSE);

for (a=1;a<256;a++)
	{
	if (a<16)
		{
		if (msg) printf("0%Xh ",a);
		}
	else
		{
		if (msg) printf("%Xh ",a);
		}
	handle_errors(_bios_serialcom(_COM_SEND,COM,(char)a ),FALSE);
	}
puts("\n if he had correctly received, the programmer turns the LED on.");
}


/****************************************************************************/
void 	erase_chip		(void)
{
puts ("\ndelete chip content");

puts (" sending:   EBh 98h 12h");
handle_errors(_bios_serialcom(_COM_SEND,COM,0xEB ),FALSE);
handle_errors(_bios_serialcom(_COM_SEND,COM,0x98 ),FALSE);
handle_errors(_bios_serialcom(_COM_SEND,COM,18 ),FALSE);

delay(500);
}

/****************************************************************************/
void 	lock_chip		(void)
{
puts ("\nlock the chip content");
puts (" place the adapter-socket between the programmer and the chip!");

puts (" press any key when ready");
getch();

puts (" sending:   EBh 98h E0h");
handle_errors(_bios_serialcom(_COM_SEND,COM,0xEB ),FALSE);
handle_errors(_bios_serialcom(_COM_SEND,COM,0x98 ),FALSE);
handle_errors(_bios_serialcom(_COM_SEND,COM,224 ),FALSE);

delay(500);
}

/****************************************************************************/
void 	write_chip		(char* file)
{
puts ("\nwrite file into the chip");

allocate();
read_file(file);

puts (" sending:   EBh 98h 04h");
handle_errors(_bios_serialcom(_COM_SEND,COM,0xEB ),FALSE);
handle_errors(_bios_serialcom(_COM_SEND,COM,0x98 ),FALSE);
handle_errors(_bios_serialcom(_COM_SEND,COM,4 ),FALSE);


for (a=0;a<l;a++)
	{
	s=(char)buffer[a];
	if (msg) printf("%02Xh ",((int)s)&0x00FF) ;
	handle_errors(_bios_serialcom(_COM_SEND,COM,s ),FALSE);
	}

delay(500);

}

/****************************************************************************/
void 	verify_chip		(char* file)
{
puts ("\nverify chip content with file");
puts (" verification is only possible with the standard programmer!");

allocate();
read_file(file);

puts (" sending:   EBh 98h 08h");
handle_errors(_bios_serialcom(_COM_SEND,COM,0xEB ),FALSE);
handle_errors(_bios_serialcom(_COM_SEND,COM,0x98 ),FALSE);
handle_errors(_bios_serialcom(_COM_SEND,COM,8 ),FALSE);

for (a=0;a<l;a++)
	{
	s=(char)buffer[a];
	if (msg) printf("%02Xh ",((int)s)&0x00FF) ;
	handle_errors(_bios_serialcom(_COM_SEND,COM,s ),FALSE);
	}


delay(500);
}

/****************************************************************************/
void	allocate		(void)
{
if (!buffer)
	{
	puts (" trying to allocate 2048 byte on heap");
	buffer=(char*)malloc(2050);
	if (!buffer)
		{
		printf ("   --- error while allocating !!!");
		exit( 255 );
		}
	}
}

/****************************************************************************/
void	read_file		(char * file)
{
if (!in)
	{
	printf (" trying to open file '%s'\n",file);
	if ((in = fopen(file, "rb"))== NULL)
		{
		printf("\n\nCannot open input file.\n");
		exit(255);
		}
	l=fread(buffer,1,2049,in);
	printf (" getting %d bytes from file\n",l);
	}

}

/****************************************************************************/
